#version 460

uniform ivec3 light_offset;
uniform vec3 sun_light;

in uint data;

out VS_OUT {
	uint voxelTexture;
	uint face;
	vec3 offset;
} vs_out;

buffer RenderData {
	int[2048] chunk_x;
	int[2048] chunk_y;
	int[2048] chunk_z;
};

void main()
{
	// Unpack the data we retrieved
	const uint x = (data) & 31; // 0-31 x position
	const uint y = (data >> 5) & 31; // 0-31 y position
	const uint z = (data >> 10) & 31; // 0-31 z position

	const uint face = (data >> 15) & 15; // 0-9 (0-15) face

	vs_out.voxelTexture = (data >> 19); // 13 bits, texture index

	// Calculate real positions
	const ivec3 offset = ivec3(chunk_x[gl_DrawID], chunk_y[gl_DrawID], chunk_z[gl_DrawID]);
	vs_out.offset = offset;
	vs_out.face = face;

	// Output our position
	gl_Position = vec4(x, y, z, 1.0);
}
